2022-09-24 13:56:17

by Leo Yan

[permalink] [raw]
Subject: [PATCH v3] perf test: Introduce script for data symbol testing

This commit introduces a shell script for data symbol testing.

The testing is designed a data structure with 64-byte alignment, it has
two fields "data1" and "data2", and other fields are reserved.

Using "perf mem" command, we can record and report memory samples for a
self-contained workload with 1 second duration. If have no any memory
sample for the data structure "buf1", it reports failure; and by
checking the offset in structure "buf1", if any memory accessing is not
for "data1" and "data2" fields, it means wrong data symbol parsing and
returns failure.

Signed-off-by: Leo Yan <[email protected]>
---

Changes from v2:
- Used 'symbol_daddr' sort key in report (Namyung);
- Didn't save source code into temp file and used pipe for compilation
(Namyung);
- Polished the C test code included in the script (Namyung).

Changes from v1:
- Removed "killall" since the test has no child process (Ian);
- Used "char" instead of "long" in the buf structure.

tools/perf/tests/shell/test_data_symbol.sh | 83 ++++++++++++++++++++++
1 file changed, 83 insertions(+)
create mode 100755 tools/perf/tests/shell/test_data_symbol.sh

diff --git a/tools/perf/tests/shell/test_data_symbol.sh b/tools/perf/tests/shell/test_data_symbol.sh
new file mode 100755
index 000000000000..a153b0d84dc0
--- /dev/null
+++ b/tools/perf/tests/shell/test_data_symbol.sh
@@ -0,0 +1,83 @@
+#!/bin/bash
+# Test data symbol
+
+# SPDX-License-Identifier: GPL-2.0
+# Leo Yan <[email protected]>, 2022
+
+skip_if_no_mem_event() {
+ perf mem record -e list 2>&1 | egrep -q 'available' && return 0
+ return 2
+}
+
+skip_if_no_mem_event || exit 2
+
+# skip if there's no compiler
+if ! [ -x "$(command -v cc)" ]; then
+ echo "skip: no compiler, install gcc"
+ exit 2
+fi
+
+TEST_PROGRAM=$(mktemp /tmp/__perf_test.program.XXXXX)
+PERF_DATA=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
+
+check_result() {
+ # The memory report format is as below:
+ # 99.92% ... [.] buf1+0x38
+ result=$(perf mem report -i ${PERF_DATA} -s symbol_daddr -q 2>&1 |
+ awk '/buf1/ { print $4 }')
+
+ # Testing is failed if has no any sample for "buf1"
+ [ -z "$result" ] && return 1
+
+ while IFS= read -r line; do
+ # The "data1" and "data2" fields in structure "buf1" have
+ # offset "0x0" and "0x38", returns failure if detect any
+ # other offset value.
+ if [ "$line" != "buf1+0x0" ] && [ "$line" != "buf1+0x38" ]; then
+ return 1
+ fi
+ done <<< "$result"
+
+ return 0
+}
+
+cleanup_files()
+{
+ echo "Cleaning up files..."
+ rm -f ${PERF_DATA}
+ rm -f ${TEST_PROGRAM}
+}
+
+trap cleanup_files exit term int
+
+# compile test program
+echo "Compiling test program..."
+cat << EOF | cc -o ${TEST_PROGRAM} -x c -
+typedef struct _buf {
+ char data1;
+ char reserved[55];
+ char data2;
+} buf __attribute__((aligned(64)));
+
+static buf buf1;
+
+int main(void) {
+ for (;;) {
+ buf1.data1++;
+ buf1.data2 += buf1.data1;
+ }
+ return 0;
+}
+EOF
+
+echo "Recording workload..."
+perf mem record --all-user -o ${PERF_DATA} -- $TEST_PROGRAM &
+PERFPID=$!
+
+sleep 1
+
+kill $PERFPID
+wait $PERFPID
+
+check_result
+exit $?
--
2.34.1


2022-09-30 07:47:01

by Ravi Bangoria

[permalink] [raw]
Subject: Re: [PATCH v3] perf test: Introduce script for data symbol testing

Hi Leo,

On 24-Sep-22 7:04 PM, Leo Yan wrote:
> This commit introduces a shell script for data symbol testing.
>
> The testing is designed a data structure with 64-byte alignment, it has
> two fields "data1" and "data2", and other fields are reserved.
>
> Using "perf mem" command, we can record and report memory samples for a
> self-contained workload with 1 second duration. If have no any memory
> sample for the data structure "buf1", it reports failure; and by
> checking the offset in structure "buf1", if any memory accessing is not
> for "data1" and "data2" fields, it means wrong data symbol parsing and
> returns failure.

I'm working on adding support for perf mem/c2c on AMD:
https://lore.kernel.org/lkml/20220928095805.596-1-ravi.bangoria%40amd.com

And this test fails on AMD because perf mem/c2c internally use IBS pmu
which does not support user/kernel filtering and per-process monitoring.
Would it be possible for you to add below (ugly) hunk to this patch:

---
diff --git a/tools/perf/tests/shell/test_data_symbol.sh b/tools/perf/tests/shell/test_data_symbol.sh
index a153b0d84dc0..212082951b12 100755
--- a/tools/perf/tests/shell/test_data_symbol.sh
+++ b/tools/perf/tests/shell/test_data_symbol.sh
@@ -71,7 +71,12 @@ int main(void) {
EOF

echo "Recording workload..."
-perf mem record --all-user -o ${PERF_DATA} -- $TEST_PROGRAM &
+is_amd=$(egrep -c 'vendor_id.*AuthenticAMD' /proc/cpuinfo)
+if (($is_amd >= 1)); then
+ perf mem record -o ${PERF_DATA} -- -C 0 -- taskset -c 0 $TEST_PROGRAM &
+else
+ perf mem record --all-user -o ${PERF_DATA} -- $TEST_PROGRAM &
+fi
PERFPID=$!

sleep 1
---

Thanks,
Ravi

2022-09-30 11:53:05

by Leo Yan

[permalink] [raw]
Subject: Re: [PATCH v3] perf test: Introduce script for data symbol testing

Hi Ravi,

On Fri, Sep 30, 2022 at 12:27:22PM +0530, Ravi Bangoria wrote:
> Hi Leo,
>
> On 24-Sep-22 7:04 PM, Leo Yan wrote:
> > This commit introduces a shell script for data symbol testing.
> >
> > The testing is designed a data structure with 64-byte alignment, it has
> > two fields "data1" and "data2", and other fields are reserved.
> >
> > Using "perf mem" command, we can record and report memory samples for a
> > self-contained workload with 1 second duration. If have no any memory
> > sample for the data structure "buf1", it reports failure; and by
> > checking the offset in structure "buf1", if any memory accessing is not
> > for "data1" and "data2" fields, it means wrong data symbol parsing and
> > returns failure.
>
> I'm working on adding support for perf mem/c2c on AMD:
> https://lore.kernel.org/lkml/20220928095805.596-1-ravi.bangoria%40amd.com
>
> And this test fails on AMD because perf mem/c2c internally use IBS pmu
> which does not support user/kernel filtering and per-process monitoring.
> Would it be possible for you to add below (ugly) hunk to this patch:

Sure, the change is fine for me, I will update patch and send out a new
version.

@Arnaldo, I saw you have merged this patch into the branch:
https://git.kernel.org/pub/scm/linux/kernel/git/acme/linux.git/log/?h=tmp.perf/core

Could you pick up the new coming patch? Please expect it would be soon.

Thanks,
Leo